/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 44.
   좮 .. - ॢ  ᪨ .
*/
/* See also pages 30ff in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* CURVFIT:         ਢ  ਬ -ᯫ
		    Curve fitting using B splines              */

 #include "stdio.h"
 #define MAX 100
 #define N 30

 main()
 { float x[MAX], y[MAX], eps=0.04, X, Y, t, xA, xB, xC, xD,
         yA, yB, yC, yD, a0, a1, a2, a3, b0, b1, b2, b3;
   int n, i, j, first;
   FILE *fp;
   fp=fopen("curv.dat", "r");
   if (fp==NULL) { printf  /* "There is no file  curv.dat"  */
			  (" 䠩 curv.dat\n"); exit(1); }
   fscanf(fp, "%d", &n);
   for (i=0; i<=n; i++)
   if (fscanf(fp, "%f %f", x+i, y+i)<=0)
   { printf  /* "Reading beyond the end of file  curv.dat" */
    ("뢠 室  । 䠩 curv.dat\n"); exit(1);
   }
      initgr();
		      /* Mark the given points:              */
		      /*  窨 ⬥ થ஬: */
   for (i=0; i<=n; i++)
   { X=x[i]; Y=y[i];
     move(X-eps, Y-eps); draw(X+eps, Y+eps);
     move(X+eps, Y-eps); draw(X-eps, Y+eps);
   }
   first=1;
   for (i=1; i<n-1; i++)
   { xA=x[i-1]; xB=x[i]; xC=x[i+1]; xD=x[i+2];
     yA=y[i-1]; yB=y[i]; yC=y[i+1]; yD=y[i+2];
     a3=(-xA+3*(xB-xC)+xD)/6.0; b3=(-yA+3*(yB-yC)+yD)/6.0;
     a2=(xA-2*xB+xC)/2.0;       b2=(yA-2*yB+yC)/2.0;
     a1=(xC-xA)/2.0;            b1=(yC-yA)/2.0;
     a0=(xA+4*xB+xC)/6.0;       b0=(yA+4*yB+yC)/6.0;
     for (j=0; j<=N; j++)
     { t=(float)j/(float)N;
       X=((a3*t+a2)*t+a1)*t+a0;
       Y=((b3*t+b2)*t+b1)*t+b0;
       if (first) { first=0; move(X, Y);} else draw(X, Y);
     }
   }
   endgr(); fclose(fp);
 }
