/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 101.
   좮 .. - ॢ  ᪨ .
*/
/* See also page 81 in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* GPERSF: General program for PERSpective, producing the    */
 /*         output File A.SCRATCH, to be read by GENPLOT      */

 /*  ணࠬ  ஥ ᯥ⨢ ࠦ, */
 /* ନ 室 䠩 A.SCRATCH, ।祭   */
 /* 뢠 ணࠬ GENPLOT                             */

 #include "math.h"
 #include "stdio.h"

 float v11, v12, v13, v21, v22, v23, v32, v33, v43;

 main(argc, argv) int argc; char *argv[];
 { float rho, theta, phi, xO, yO, zO, x, y, z;
   FILE *fpin, *fpout;
   struct { float X, Y; int code; } s;
   if (argc != 2) { printf /* "No input file given" */
			  (" 㪠 室 䠩"); exit(1); }
   if (fpin=fopen(argv[1],"r"), fpin==NULL)
   { printf /* "File ... does not exist" */
	   ("   %s  ", argv[1]); exit(1);
   }
   fscanf(fpin, "%f %f %f", &xO, &yO, &zO); skipf(fpin);
   fscanf(fpin, "%f %f %f", &rho, &theta, &phi);
   coeff(rho, theta, phi);
   fpout=fopen("a.scratch", "wb");
   while (skipf(fpin), fscanf(fpin, "%f %f %f %d",
                                 &x, &y, &z, &s.code) > 0)
   { perspect(x-xO, y-yO, z-zO, &s.X, &s.Y);
     fwrite(&s, sizeof s, 1, fpout);
   }
   fclose(fpout);
 }

 skipf(fpin) FILE *fpin; { while (getc(fpin) != '\n'); }

 coeff(rho, theta, phi) float rho, theta, phi;
 { float th, ph, costh, sinth, cosph, sinph, factor;
   factor=atan(1.0)/45.0;
	       /* Angles in radians: */ /*   ࠤ */
   th=theta*factor; ph=phi*factor;
   costh=cos(th); sinth=sin(th);
   cosph=cos(ph); sinph=sin(ph);
   		     /* Elements of matrix V, see Eq. (4-9): */
		     /*   V, . (4.9):       */
   v11=-sinth; v12=-cosph*costh; v13=-sinph*costh;
   v21=costh;  v22=-cosph*sinth; v23=-sinph*sinth;
               v32=sinph;        v33=-cosph;
                                 v43=rho;
 }

 perspect(x, y, z, pX, pY) float x, y, z, *pX, *pY;
 { float xe, ye, ze;
	       /* Eye coordinates, computed as in Eq. (4-2): */
	       /*  न, 塞   (4.2): */
   xe = v11*x + v21*y;
   ye = v12*x + v22*y + v32*z;
   ze = v13*x + v23*y + v33*z + v43;

 /* Screen coordinates, to be adjusted by GENPLOT            */
 /* ࠭ न, 뢠  ணࠬ GENPLOT */
   *pX = xe/ze;
   *pY = ye/ze;
 }

   /* End of program GPERSF */     /*  ணࠬ GPERSF */