/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 15.
   좮 .. - ॢ  ᪨ .
*/
/* See also pages 6ff of:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* QUADRANT1:                                              */
 /*  ணࠬ  14 ५,   ࠢ  */
 /* ⨢ ᮢ ५  ⭮⥫쭮  窨   ࢮ  */
 /* ࠭ न⭮ ⥬                          */
 /* This program draws 14 arrows, flying counter-clockwise  */
 /* about O in the first quadrant of the coordinate system  */

 #include "math.h"

 float x[4]={ 6.0,  6.0,  5.9,  6.1}, /*  See Figure below  */
       y[4]={-0.25, 0.25, 0.0,  0.0}; /*  in this program   */
		    /* . 㭮    ணࠬ  */
 main()
 { int i, j;
   float pi, phi, cos_phi, sin_phi, xx, yy;
   pi=4.0*atan(1.0); phi=6*pi/180;
   cos_phi=cos(phi); sin_phi=sin(phi);
   initgr();
   for (i=1; i<=14; i++)              /*  Initial position  */
   { /*  Rotate the arrow: */         /*  of the arrow:     */
     /*  ५ : */          /*  砫쭠 :*/
     for (j=0; j<=3; j++)             /*                    */
     { xx=x[j]; yy=y[j];              /*     (6, 0.25)      */
       x[j]=xx*cos_phi-yy*sin_phi;    /*         1          */
       y[j]=xx*sin_phi+yy*cos_phi;    /*         ^          */
     }                                /*        /|\         */
  /*  Draw the rotated arrow:      */ /*      2/___\3       */
  /* ᮢ  ⮩ ५ */ /* (5.9, 0)| (6.1, 0) */
     move(x[0], y[0]);                /*         |          */
     for (j=1; j<=3; j++)             /*         0          */
           draw(x[j], y[j]);          /*      (6, -0.25)    */
     draw(x[1], y[1]);                /*                    */
   }                                  /**********************/
   endgr();
 }


