/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 17.
   좮 .. - ॢ  ᪨ .
*/
/* See also pages 8 and 9 in:
   L. Ammeraal (1986). Programming Principles in Computer
   Graphics,  Chichester: John Wiley & Sons.
*/

 /* ARROWS30:                                                  */
 /*  ணࠬ 稢 30 ५  㦭        */
 /* 業஬  窥 (x0,y0)                                    */
 /*                                                            */
 /* This program draws 30 arrows, flying counter-clockwise     */
 /* about point (x0, y0)                                       */

 #include "math.h"
 float x[4]={ 0.0,  0.0, -0.08, 0.08},   /* See Figure below   */
       y[4]={-0.25, 0.25, 0.0,  0.0 };   /* in this program    */
			  /* . 㭮   ⮩ ணࠬ */

 main()
 { int i, j;
   float pi, phi, cos_phi, sin_phi, dx, dy,
         x0=4.5, y0=3.5, r=3.0;
   pi=4.0*atan(1.0); phi=12*pi/180;
   cos_phi=cos(phi); sin_phi=sin(phi);
   initgr();
		 /* ७  砫  (x0+r, y0) :  */
		 /* Move to start position (x0+r, y0) :       */
   for (j=0; j<4; j++) { x[j]+=x0+r; y[j]+=y0; }
   for (i=0; i<30; i++)
   { /* Rotate the arrow: */          /*  Initial position:   */
     /*  ५ : */          /*  砫쭠 :  */
     for (j=0; j<4; j++)              /*                      */
     { dx=x[j]-x0; dy=y[j]-y0;        /*        (0, 0.12)     */
       x[j]=x0+dx*cos_phi-dy*sin_phi; /*           1          */
       y[j]=y0+dx*sin_phi+dy*cos_phi; /*           ^          */
     }                                /*          /|\         */
  /* Draw the rotated arrow:       */ /*        2/___\3       */
  /* ᮢ  ⮩ ५ */ /*(-0.04, 0) | (0.04, 0)*/
     move(x[0], y[0]);                /*           |          */
     for (j=1; j<=3; j++)             /*           |          */
             draw(x[j], y[j]);        /*           0          */
     draw(x[1], y[1]);                /*        (0, -0.12)    */
   }                                  /*                      */
   endgr();                           /************************/
 }

