/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 93.
   좮 .. - ॢ  ᪨ .
*/
/* See also page 74 in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* CUBE:                  ஢筠  㡠
			   A wire frame model of a cube */

 #include "math.h"

 float v11, v12, v13, v21, v22, v23, v32, v33, v43,
       screen_dist, c1=4.5, c2=3.5;

 main()
 { float rho, theta, phi, h=50.0;
   printf /* "Viewing distance rho = EO"  */
	  ("ﭨ  ⥫ rho = EO:  ");
	   scanf("%f", &rho);
   printf /* "Give two angles, in degrees." */
	 ("\n  㣫  ࠤ.\n");
   printf /* "Theta, measured horizontally from the x-axis:" */
	  (" theta   ਧ⠫   x: ");
   scanf("%f", &theta);
   printf /* "Phi, measured vertically from the z-axis:" */
	  ("  phi     ⨪    z: ");
   scanf("%f", &phi);
   printf /* "Distance from viewpoint to screen:" */
	  ("ﭨ  窨   ࠭:      ");
   scanf("%f", &screen_dist);
   coeff(rho, theta, phi);
   initgr();
   mv(h, -h, -h); dw(h, h, -h);    /* draw AB */ /* १ AB */
   dw(-h, h, -h);                  /* draw BC */ /* १ BC */
   dw(-h, h, h);                   /* draw CG */ /* १ CG */
   dw(-h, -h, h);                  /* draw GH */ /* १ GH */
   dw(h, -h, h);                   /* draw HE */ /* १ HE */
   dw(h, -h, -h);                  /* draw EA */ /* १ EA */
   mv(h, h, -h); dw(h, h, h);      /* draw BF */ /* १ BF */
   dw(-h, h, h);                   /* draw FG */ /* १ FG */
   mv(h, h, h); dw(h, -h, h);      /* draw FE */ /* १ FE */
   mv(h, -h, -h); dw(-h, -h, -h);  /* draw AD */ /* १ AD */
   dw(-h, h, -h);                  /* draw DC */ /* १ DC */
   mv(-h, -h, -h); dw(-h, -h, h);  /* draw DH */ /* १ DH */
   endgr();
 }

 coeff(rho, theta, phi) float rho, theta, phi;
 { float th, ph, costh, sinth, cosph, sinph, factor;
   factor=atan(1.0)/45.0;
		  /* Angles in radians: */  /*   ࠤ */
   th=theta*factor; ph=phi*factor;
   costh=cos(th); sinth=sin(th);
   cosph=cos(ph); sinph=sin(ph);
		       /* Elements of matrix V, see Eq. (4-9): */
		       /*   V, . (4.9):       */
   v11=-sinth; v12=-cosph*costh; v13=-sinph*costh;
   v21=costh;  v22=-cosph*sinth; v23=-sinph*sinth;
               v32=sinph;        v33=-cosph;
                                 v43=rho;
 }

 mv(x, y, z) float x, y, z;
 { float X, Y;
   perspective(x, y, z, &X, &Y);
   move(X, Y);
 }

 dw(x, y, z) float x, y, z;
 { float X, Y;
   perspective(x, y, z, &X, &Y);
   draw(X, Y);
 }

 perspective(x, y, z, pX, pY) float x, y, z, *pX, *pY;
 { float xe, ye, ze;

   /* Eye coordinates, computed as in Eq. (4-2): */
   /* न , 塞  (4.2):    */
   xe = v11*x + v21*y;
   ye = v12*x + v22*y + v32*z;
   ze = v13*x + v23*y + v33*z + v43;

   /* Screen coordinates, computed as   */
   /* in Eqs. (4-12) and (4-13):        */
   /* ࠭ न, 塞  (4.12)  (4.13) */
   *pX = screen_dist*xe/ze + c1;
   *pY = screen_dist*ye/ze + c2;
 }
