/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 34.
   좮 .. - ॢ  ᪨ .
*/
/* See also page 23 in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* GENPLOT:                                               */
 /*    A general adjusting and plotting program.           */
 /*    The file A.SCRATCH contains input data.             */
 /*     ணࠬ । ࠧ஢  稢 */
 /*     䠩 A.SCRATCH ᮤঠ 室          */

 #include "stdio.h"

 main()
 { float x, y, xmin, xmax, ymin, ymax, X, Y, Xmin, Xmax,
         Ymin, Ymax, fx, fy, f, xC, yC, XC, YC, c1, c2;
   FILE *fp;
   struct {float xx; float yy; int ii;} s;
   fp=fopen("a.scratch", "rb");
    /* ࠬ "rb" 室  ⥭  ୮ ० */
    /* required in Lattice C for binary mode                */
   xmin=ymin=1e30; xmax=ymax=-xmin;
   while (fread(&s, sizeof s, 1, fp))
   { x=s.xx; y=s.yy;
     if (x<xmin) xmin=x;
     if (x>xmax) xmax=x;
     if (y<ymin) ymin=y;
     if (y>ymax) ymax=y;
   }
   fclose(fp);
   init_viewport(&Xmin, &Xmax, &Ymin, &Ymax);
   fx=(Xmax-Xmin)/(xmax-xmin); fy=(Ymax-Ymin)/(ymax-ymin);
   f=(fx<fy?fx:fy);
   xC=0.5*(xmin+xmax); yC=0.5*(ymin+ymax);
   XC=0.5*(Xmin+Xmax); YC=0.5*(Ymin+Ymax);
   c1=XC-f*xC; c2=YC-f*yC;
   fp=fopen("a.scratch", "rb"); /* Lattice C:  ० */
				/* Lattice C: binary mode    */
   while (fread(&s, sizeof s, 1, fp))
   { x=s.xx; y=s.yy;
     X=f*x+c1; Y=f*y+c2;
     if (s.ii) draw(X, Y); else move(X, Y);
   }
   fclose(fp); endgr();
 }

 init_viewport(pXmin, pXmax, pYmin, pYmax)
   float *pXmin, *pXmax, *pYmin, *pYmax;
 { float Xmin, Xmax, Ymin, Ymax, eps=0.2;
   printf /* "Give viewport boundaries */
    (" ࠭  뢮 Xmin, Xmax, Ymin, Ymax\n");
   scanf("%f %f %f %f", &Xmin, &Xmax, &Ymin, &Ymax);
		    /* ⬥  㣫  뢮: */
		    /* Show the four viewport corners:        */
   initgr();
   move(Xmin, Ymin+eps); draw(Xmin, Ymin); draw(Xmin+eps, Ymin);
   move(Xmax-eps, Ymin); draw(Xmax, Ymin); draw(Xmax, Ymin+eps);
   move(Xmax, Ymax-eps); draw(Xmax, Ymax); draw(Xmax-eps, Ymax);
   move(Xmin+eps, Ymax); draw(Xmin, Ymax); draw(Xmin, Ymax-eps);
   move((Xmin+Xmax)/2, Ymin); draw((Xmin+Xmax)/2, Ymin);
      /* 窠  ।  ࠭  ਥ樨       */
      /* Dot in the middle of bottom boundary for orientation */
   *pXmin=Xmin; *pXmax=Xmax; *pYmin=Ymin; *pYmax=Ymax;
 }
