/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 39.
   좮 .. - ॢ  ᪨ .
*/
/* See also page 27 in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* PYTHTREE:                       ਠ ॢ 䠣
			  Variants of the tree of Pythagoras   */

 #include "math.h"
 #include "time.h"

 #define pi 3.1415927

 int delta;
 long int seed;

 main()
 { int n;
   pfopen(); time(&seed); srand((int)seed);
   printf /* "Give angle delta in degrees (0 < delta < 45)" */
	  (" 㣮 delta  ࠤ (0 < delta < 45)\n");
   scanf("%d", &delta);
   printf /* "Give recursion depth n") */
	  (" 㡨 ४ᨨ n\n"); scanf("%d", &n);
   square_and_triangle(n, 0.0, 0.0, 1.0, 0.0);
   pfclose();
 }

 square_and_triangle(n, x0, y0, a, phi)
    int n; float x0, y0, a, phi;
 { float x[5], y[5], xx[5], yy[5], cphi, sphi, c1, c2, b, c,
         alpha, calpha, salpha;
   int i, deviation;            /* phi and alpha in radians    */
				/* delta in degrees            */
   if (n==0) return;    	/* 㣫 phi  alpha  ࠤ */
				/* 㣮 delta  ࠤ       */
   deviation=rand()%(2*delta+1)-delta;
   alpha=(45+deviation)*pi/180.0;
   x[0]=x[3]=x0; x[1]=x[2]=x0+a;
   y[0]=y[1]=y0; y[2]=y[3]=y0+a;
   calpha=cos(alpha); salpha=sin(alpha);
   c=a*calpha; b=a*salpha;
   x[4]=x[3]+c*calpha;
   y[4]=y[3]+c*salpha;
	      /* Rotation about (x0, y0) through angle phi;   */
	      /* this was explained in Section 2-3            */
	      /*   窨 (x0, y0)  㣮 phi;   */
	      /*   뫠 ᠭ  ࠧ 2.3      */
   cphi=cos(phi); sphi=sin(phi);
   c1=x0-x0*cphi+y0*sphi;
   c2=y0-x0*sphi-y0*cphi;
   for (i=0; i<5; i++)
   { xx[i]=x[i]*cphi-y[i]*sphi+c1;
     yy[i]=x[i]*sphi+y[i]*cphi+c2;
   }
   pmove(xx[3], yy[3]);
   for (i=0; i<5; i++) pdraw(xx[i], yy[i]);
   pdraw(xx[2], yy[2]);
   square_and_triangle(n-1, xx[3], yy[3], c, phi+alpha);
   square_and_triangle(n-1, xx[4], yy[4], b, phi+alpha-0.5*pi);
 }

 #include "stdio.h"
 FILE *fp;
 struct {float xx; float yy; int ii;} s;

 pfopen() { fp=fopen("a.scratch", "wb"); }

 pmove(x, y) float x, y;
 { s.xx=x; s.yy=y; s.ii=0; /* 0 = pen up *//* 0 =   */
   fwrite(&s, sizeof s, 1, fp);
 }

 pdraw(x, y) float x, y;
 { s.xx=x; s.yy=y; s.ii=1; /* 1 = pen down *//* 1 =  饭 */
   fwrite(&s, sizeof s, 1, fp);
 }

 pfclose() { fclose(fp); }

