/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 36.
   좮 .. - ॢ  ᪨ .
*/
/* See also page 25 in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* STARS:                      ࠧ ࠧ஢
				  Stars of various sizes */
 #include "math.h"

 main()
 { pfopen(); star(0.0, 0.0, 1.0); pfclose();
 }

 star(xC, yC, r) float xC, yC, r;
 { float phi, r_half, r_double,
	 factor=0.0174533;           /* factor = pi/180 */
   int i;
   if (r<0.1) return;
   pmove(xC+r, yC);
   for (i=1; i<=5; i++)
   { phi=i*144*factor;
     pdraw(xC+r*cos(phi), yC+r*sin(phi));
   }
   r_half=0.5*r; r_double=2*r;
   for (i=0; i<5; i++)
   { phi=(36+i*72)*factor;
     star(xC+r_double*cos(phi), yC+r_double*sin(phi), r_half);
   }
 }


 #include "stdio.h"
 FILE *fp;
 struct {float xx; float yy; int ii;} s;

 pfopen() { fp=fopen("a.scratch", "wb"); }

 pmove(x, y) float x, y;
 { s.xx=x; s.yy=y; s.ii=0; /* 0 = pen up */  /* 0 =   */
   fwrite(&s, sizeof s, 1, fp);
 }

 pdraw(x, y) float x, y;
 { s.xx=x; s.yy=y; s.ii=1; /* 1 = pen down */ /* 1 =  饭 */
   fwrite(&s, sizeof s, 1, fp);
 }

 pfclose() { fclose(fp); }

